# uniqueid [![NPM version](https://badge.fury.io/js/uniqueid.svg)](http://badge.fury.io/js/uniqueid)


> Generate a unique, sequential ID. Optionally pass a prefix, suffix, or multiplier.

## Install
#### Install with [npm](npmjs.org):

```bash
npm i uniqueid --save-dev
```

## Run tests

```bash
npm test
```

## Usage

```js
var uniqueId = require('uniqueid');
console.log(uniqueId('abc'));
//=> ['a', 'b', 'c'];
```

## API
### [id](index.js#L32)

Generate a unique ID.

* `options` **{Object}**: Optionally pass a `prefix`, `suffix` and/or `multiplier.    
* `returns` **{String}**: The unique id.  

Optionally pass a prefix to prepend, a suffix to append, or a
multiplier to use on the ID.

```js
uniqueId(); //=> '25'

uniqueId({prefix: 'apple_'});
//=> 'apple_10'

uniqueId({suffix: '_orange'});
//=> '10_orange'

uniqueId({multiplier: 5});
//=> 5, 10, 15, 20...
```

To reset the `id` to zero, do `id.reset()`.

## Author

**Jon Schlinkert**
 
+ [github/jonschlinkert](https://github.com/jonschlinkert)
+ [twitter/jonschlinkert](http://twitter.com/jonschlinkert) 

## License
Copyright (c) 2014 Jon Schlinkert, contributors.  
Released under the MIT license

***

_This file was generated by [verb-cli](https://github.com/assemble/verb-cli) on September 14, 2014._